/** @file camogm_jpeg.h
 * @brief Provides writing to series of individual JPEG files for @e camogm
 * @copyright Copyright (C) 2016 Elphel, Inc.
 *
 * @par <b>License</b>
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CAMOGM_JPEG_H
#define _CAMOGM_JPEG_H
//#define __USE_GNU // for O_DIRECT

#include "camogm.h"

int camogm_init_jpeg(camogm_state *state);
int camogm_start_jpeg(camogm_state *state);
int camogm_frame_jpeg(camogm_state *state);
int camogm_end_jpeg(camogm_state *state);
void camogm_free_jpeg(camogm_state *state);
int open_state_file(const rawdev_buffer *rawdev, uint64_t *current_pos);
ssize_t emul_writev (int fd, const struct iovec *iovec, int count);
int get_write_page(struct writer_params *wparams);
int get_num_empty(struct writer_params *wparams);
int get_num_busy(struct writer_params *wparams);

int get_dir_path(char* file_path, char* directory); // directory should be allocated, returns w/o trailing '/'
int getup_state_files(camogm_state *state); // rawdev_buffer *rawdev);

int set_state_file_from_prefix(camogm_state *state, const char * prefix);
char * get_state_path(camogm_state *state);
void next_state_path(camogm_state *state);
int copy_state_file(camogm_state *state);
int copy_file(const char *from, const char *to);

#define STATE_EXT          ".disk"
//#define STATE_FMT          "%s_%04d"STATE_EXT
#define STATE_FMT          "%s_%04d.disk"
#define STATE_SFMT         "%s %d"
#define STATE_PREF_DFLT    "test"


#endif /* _CAMOGM_JPEG_H */
